#.
# json.rb
#.
# Copyright 2014 by siberas, http://www.siberas.de
# This file is part of WATOBO (Web Application Tool Box) http://watobo.sourceforge.com
# WATOBO is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 2 of the License.
# WATOBO is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with WATOBO; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

# @private 
module Watobo#:nodoc: all
  module HTTPData
   
    class JSONData < Base
      
      def to_s
        s = @root.body.nil? ? "" : @root.body
      end
      
      def set(parm)
         parms = JSON.parse(@root.body.to_s)
         parms[parm.name] = parm.value
         @root.set_body parms.to_json
      end

      def has_parm?(parm_name)
        parms = JSON.parse(@root.body.to_s)
        return true if parms.has_key? parm_name
        false
      end

      def parameters(&block)
        parms = []
        json_str = @root.body.to_s
        
        JSON.parse(json_str).each do |k,v|
          val = v.is_a?(String) ? v : v.to_s
          parms << Watobo::JSONParameter.new( :name => k, :value => val )
        end
        parms
      end

      def initialize(root)
        super root

      end
    end

  end

end