#.
# status.rb
#.
# Copyright 2014 by siberas, http://www.siberas.de
# This file is part of WATOBO (Web Application Tool Box) http://watobo.sourceforge.com
# WATOBO is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 2 of the License.
# WATOBO is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with WATOBO; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

module Watobo
  module Crawler
    module Status
      include Watobo::Plugin::Crawler::Constants

      @status_lock = Mutex.new
      @request_count = 0
      @engine_status = CRAWL_NONE
      @page_size = 0
      @link_size = 0
      
      def self.reset
        @request_count = 0
        @engine_status = CRAWL_NONE
        @page_size = 0
      end

      def self.page_size=(ps)
        @status_lock.synchronize do
          @page_size= ps
        end
        true
      end

      def self.link_size=(ps)
        @status_lock.synchronize do
          @link_size= ps
        end
        true
      end

      def self.engine=(s)
        @status_lock.synchronize do
          @engine_status = s
        end
      end

      def self.engine
        e = nil
        @status_lock.synchronize do
          e = @engine_status
        end
        e
      end

      def self.inc_requests(i = 1)
        @status_lock.synchronize do
          @request_count += i
        end
      end

      def self.set(status)
        @status_lock.synchronize do

        end
      end

      def self.get
        s = {}
        @status_lock.synchronize do
          s = {
            :engine_status => @engine_status,
            :total_requests => @request_count,
            :page_size => @page_size,
            :link_size => @link_size
            # :skipped_domains => 0
          }
        end
        s
      end
    end
  end
end